#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

typedef struct _tree_node{
	int value;
	int count;
	struct _tree_node *left;
	struct _tree_node *right;
} treeNode;

treeNode *new(int val){
	treeNode *p = malloc(sizeof(treeNode));
	assert(p != NULL);
	p->value = val;
	p->count = 1;
	p->left = NULL;
	p->right = NULL;
	return p;
}

treeNode *addRecursive(int val, treeNode *root){
	if(root == NULL) //exit condition
		return new(val);
	if(val == root->value)
		root->count++; //nothing is added
	if(val < root->value)
		root->left = addRecursive(val, root->left); //add left
	if(val > root->value)
		root->right = addRecursive(val, root->right); //add right
	return root;
}

void printRecursive(treeNode *root){
	if(root == NULL) //exit condition
		return;
	printRecursive(root->left);
	printf("%d (%d)\n", root->value, root->count);
	printRecursive(root->right);
}

#define MAX 10000

int main(void){
	int i;
	treeNode *root = NULL;
	for(i = 0; i < MAX; i++)
		root = addRecursive(rand() % (2 * MAX), root);
	printRecursive(root);
	return 0;
}